{
  This file was automatically generated on 2021-01-15.

  Delphi/Lazarus Bindings Version 2.1.30

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletOneWire;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_ONE_WIRE_DEVICE_IDENTIFIER = 2123;
  BRICKLET_ONE_WIRE_DEVICE_DISPLAY_NAME = 'One Wire Bricklet';

  BRICKLET_ONE_WIRE_FUNCTION_SEARCH_BUS_LOW_LEVEL = 1;
  BRICKLET_ONE_WIRE_FUNCTION_RESET_BUS = 2;
  BRICKLET_ONE_WIRE_FUNCTION_WRITE = 3;
  BRICKLET_ONE_WIRE_FUNCTION_READ = 4;
  BRICKLET_ONE_WIRE_FUNCTION_WRITE_COMMAND = 5;
  BRICKLET_ONE_WIRE_FUNCTION_SET_COMMUNICATION_LED_CONFIG = 6;
  BRICKLET_ONE_WIRE_FUNCTION_GET_COMMUNICATION_LED_CONFIG = 7;
  BRICKLET_ONE_WIRE_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_ONE_WIRE_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_ONE_WIRE_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_ONE_WIRE_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_ONE_WIRE_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_ONE_WIRE_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_ONE_WIRE_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_ONE_WIRE_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_ONE_WIRE_FUNCTION_RESET = 243;
  BRICKLET_ONE_WIRE_FUNCTION_WRITE_UID = 248;
  BRICKLET_ONE_WIRE_FUNCTION_READ_UID = 249;
  BRICKLET_ONE_WIRE_FUNCTION_GET_IDENTITY = 255;


  BRICKLET_ONE_WIRE_STATUS_OK = 0;
  BRICKLET_ONE_WIRE_STATUS_BUSY = 1;
  BRICKLET_ONE_WIRE_STATUS_NO_PRESENCE = 2;
  BRICKLET_ONE_WIRE_STATUS_TIMEOUT = 3;
  BRICKLET_ONE_WIRE_STATUS_ERROR = 4;
  BRICKLET_ONE_WIRE_COMMUNICATION_LED_CONFIG_OFF = 0;
  BRICKLET_ONE_WIRE_COMMUNICATION_LED_CONFIG_ON = 1;
  BRICKLET_ONE_WIRE_COMMUNICATION_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_ONE_WIRE_COMMUNICATION_LED_CONFIG_SHOW_COMMUNICATION = 3;
  BRICKLET_ONE_WIRE_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_ONE_WIRE_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_ONE_WIRE_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_ONE_WIRE_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_ONE_WIRE_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_ONE_WIRE_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_ONE_WIRE_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_ONE_WIRE_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_ONE_WIRE_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_ONE_WIRE_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_ONE_WIRE_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_ONE_WIRE_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_ONE_WIRE_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_ONE_WIRE_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_ONE_WIRE_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;
  TArray0To6OfUInt64 = array [0..6] of uint64;
  TArrayOfUInt64 = array of uint64;

  /// <summary>
  ///  Communicates with up 64 1-Wire devices
  /// </summary>
  TBrickletOneWire = class(TDevice)
  private
    streamMutex: TCriticalSection;
  protected
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns a list of up to 64 identifiers of the connected 1-Wire devices.
    ///  Each identifier is 64-bit and consists of 8-bit family code, 48-bit ID and
    ///  8-bit CRC.
    ///  
    ///  To get these identifiers the Bricklet runs the
    ///  `SEARCH ROM algorithm &lt;https://www.maximintegrated.com/en/app-notes/index.mvp/id/187&gt;`__,
    ///  as defined by Maxim.
    /// </summary>
    procedure SearchBusLowLevel(out identifierLength: word; out identifierChunkOffset: word; out identifierChunkData: TArray0To6OfUInt64; out status: byte); virtual;

    /// <summary>
    ///  Returns a list of up to 64 identifiers of the connected 1-Wire devices.
    ///  Each identifier is 64-bit and consists of 8-bit family code, 48-bit ID and
    ///  8-bit CRC.
    ///  
    ///  To get these identifiers the Bricklet runs the
    ///  `SEARCH ROM algorithm &lt;https://www.maximintegrated.com/en/app-notes/index.mvp/id/187&gt;`__,
    ///  as defined by Maxim.
    /// </summary>
    procedure SearchBus(out identifier: TArrayOfUInt64; out status: byte); virtual;

    /// <summary>
    ///  Resets the bus with the 1-Wire reset operation.
    /// </summary>
    function ResetBus: byte; virtual;

    /// <summary>
    ///  Writes a byte of data to the 1-Wire bus.
    /// </summary>
    function Write(const data: byte): byte; virtual;

    /// <summary>
    ///  Reads a byte of data from the 1-Wire bus.
    /// </summary>
    procedure Read(out data: byte; out status: byte); virtual;

    /// <summary>
    ///  Writes a command to the 1-Wire device with the given identifier. You can obtain
    ///  the identifier by calling <see cref="BrickletOneWire.TBrickletOneWire.SearchBus"/>. The MATCH ROM operation is used to
    ///  write the command.
    ///  
    ///  If you only have one device connected or want to broadcast to all devices
    ///  you can set the identifier to 0. In this case the SKIP ROM operation is used to
    ///  write the command.
    /// </summary>
    function WriteCommand(const identifier: uint64; const command: byte): byte; virtual;

    /// <summary>
    ///  Sets the communication LED configuration. By default the LED shows 1-wire
    ///  communication traffic by flickering.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is off.
    /// </summary>
    procedure SetCommunicationLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletOneWire.TBrickletOneWire.SetCommunicationLEDConfig"/>
    /// </summary>
    function GetCommunicationLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletOneWire.TBrickletOneWire.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletOneWire.TBrickletOneWire.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletOneWire.TBrickletOneWire.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletOneWire.TBrickletOneWire.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;
  end;

implementation

constructor TBrickletOneWire.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_ONE_WIRE_DEVICE_IDENTIFIER, BRICKLET_ONE_WIRE_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_SEARCH_BUS_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_RESET_BUS] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_WRITE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_READ] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_WRITE_COMMAND] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_SET_COMMUNICATION_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_GET_COMMUNICATION_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ONE_WIRE_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  streamMutex := TCriticalSection.Create;


  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletOneWire.SearchBusLowLevel(out identifierLength: word; out identifierChunkOffset: word; out identifierChunkData: TArray0To6OfUInt64; out status: byte);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_SEARCH_BUS_LOW_LEVEL, 8);
  response := SendRequest(request, 69);
  identifierLength := LEConvertUInt16From(8, response);
  identifierChunkOffset := LEConvertUInt16From(10, response);
  for i := 0 to 6 do identifierChunkData[i] := LEConvertUInt64From(12 + (i * 8), response);
  status := LEConvertUInt8From(68, response);
end;

procedure TBrickletOneWire.SearchBus(out identifier: TArrayOfUInt64; out status: byte);
var
  identifierCurrentLength: word;
  identifierLength: word;
  identifierChunkOffset: word;
  identifierChunkData: TArray0To6OfUInt64;
  identifierOutOfSync: boolean;
  identifierChunkLength: word;
begin
  streamMutex.Acquire;
  try
    identifierLength := 0;
    SearchBusLowLevel(identifierLength, identifierChunkOffset, identifierChunkData, status);
    SetLength(identifier, identifierLength);
    identifierOutOfSync := (identifierChunkOffset <> 0);

    if ((not identifierOutOfSync) and (identifierLength > 0)) then begin
      identifierChunkLength := identifierLength - identifierChunkOffset;
      if (identifierChunkLength > 7) then identifierChunkLength := 7;
      Move(identifierChunkData, identifier[0], SizeOf(uint64) * identifierChunkLength);
      identifierCurrentLength := identifierChunkLength;

      while ((not identifierOutOfSync) and (identifierCurrentLength < identifierLength)) do begin
        SearchBusLowLevel(identifierLength, identifierChunkOffset, identifierChunkData, status);
        identifierOutOfSync := identifierChunkOffset <> identifierCurrentLength;
        identifierChunkLength := identifierLength - identifierChunkOffset;
        if (identifierChunkLength > 7) then identifierChunkLength := 7;
        Move(identifierChunkData, identifier[identifierCurrentLength], SizeOf(uint64) * identifierChunkLength);
        Inc(identifierCurrentLength, identifierChunkLength);
      end;
    end;

    if (identifierOutOfSync) then begin
      { Discard remaining stream to bring it back in-sync }
      while (identifierChunkOffset + 7 < identifierLength) do begin
        SearchBusLowLevel(identifierLength, identifierChunkOffset, identifierChunkData, status);
      end;

      raise EStreamOutOfSyncException.Create('Identifier stream out-of-sync');
    end;
  finally
    streamMutex.Release;
  end;
end;

function TBrickletOneWire.ResetBus: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_RESET_BUS, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletOneWire.Write(const data: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_WRITE, 9);
  LEConvertUInt8To(data, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletOneWire.Read(out data: byte; out status: byte);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_READ, 8);
  response := SendRequest(request, 10);
  data := LEConvertUInt8From(8, response);
  status := LEConvertUInt8From(9, response);
end;

function TBrickletOneWire.WriteCommand(const identifier: uint64; const command: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_WRITE_COMMAND, 17);
  LEConvertUInt64To(identifier, 8, request);
  LEConvertUInt8To(command, 16, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletOneWire.SetCommunicationLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_SET_COMMUNICATION_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletOneWire.GetCommunicationLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_GET_COMMUNICATION_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletOneWire.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletOneWire.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletOneWire.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletOneWire.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletOneWire.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletOneWire.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletOneWire.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletOneWire.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletOneWire.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletOneWire.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletOneWire.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletOneWire.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ONE_WIRE_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

end.
