{
  This file was automatically generated on 2021-01-15.

  Delphi/Lazarus Bindings Version 2.1.30

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletRotaryEncoder;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_ROTARY_ENCODER_DEVICE_IDENTIFIER = 236;
  BRICKLET_ROTARY_ENCODER_DEVICE_DISPLAY_NAME = 'Rotary Encoder Bricklet';

  BRICKLET_ROTARY_ENCODER_FUNCTION_GET_COUNT = 1;
  BRICKLET_ROTARY_ENCODER_FUNCTION_SET_COUNT_CALLBACK_PERIOD = 2;
  BRICKLET_ROTARY_ENCODER_FUNCTION_GET_COUNT_CALLBACK_PERIOD = 3;
  BRICKLET_ROTARY_ENCODER_FUNCTION_SET_COUNT_CALLBACK_THRESHOLD = 4;
  BRICKLET_ROTARY_ENCODER_FUNCTION_GET_COUNT_CALLBACK_THRESHOLD = 5;
  BRICKLET_ROTARY_ENCODER_FUNCTION_SET_DEBOUNCE_PERIOD = 6;
  BRICKLET_ROTARY_ENCODER_FUNCTION_GET_DEBOUNCE_PERIOD = 7;
  BRICKLET_ROTARY_ENCODER_FUNCTION_IS_PRESSED = 10;
  BRICKLET_ROTARY_ENCODER_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_ROTARY_ENCODER_CALLBACK_COUNT = 8;
  BRICKLET_ROTARY_ENCODER_CALLBACK_COUNT_REACHED = 9;
  BRICKLET_ROTARY_ENCODER_CALLBACK_PRESSED = 11;
  BRICKLET_ROTARY_ENCODER_CALLBACK_RELEASED = 12;

  BRICKLET_ROTARY_ENCODER_THRESHOLD_OPTION_OFF = 'x';
  BRICKLET_ROTARY_ENCODER_THRESHOLD_OPTION_OUTSIDE = 'o';
  BRICKLET_ROTARY_ENCODER_THRESHOLD_OPTION_INSIDE = 'i';
  BRICKLET_ROTARY_ENCODER_THRESHOLD_OPTION_SMALLER = '<';
  BRICKLET_ROTARY_ENCODER_THRESHOLD_OPTION_GREATER = '>';

type
  TArray0To2OfUInt8 = array [0..2] of byte;

  TBrickletRotaryEncoder = class;
  TBrickletRotaryEncoderNotifyCount = procedure(sender: TBrickletRotaryEncoder; const count: longint) of object;
  TBrickletRotaryEncoderNotifyCountReached = procedure(sender: TBrickletRotaryEncoder; const count: longint) of object;
  TBrickletRotaryEncoderNotifyPressed = procedure(sender: TBrickletRotaryEncoder) of object;
  TBrickletRotaryEncoderNotifyReleased = procedure(sender: TBrickletRotaryEncoder) of object;

  /// <summary>
  ///  360° rotary encoder with push-button
  /// </summary>
  TBrickletRotaryEncoder = class(TDevice)
  private
    countCallback: TBrickletRotaryEncoderNotifyCount;
    countReachedCallback: TBrickletRotaryEncoderNotifyCountReached;
    pressedCallback: TBrickletRotaryEncoderNotifyPressed;
    releasedCallback: TBrickletRotaryEncoderNotifyReleased;
  protected
    procedure CallbackWrapperCount(const packet: TByteArray); virtual;
    procedure CallbackWrapperCountReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperPressed(const packet: TByteArray); virtual;
    procedure CallbackWrapperReleased(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the current count of the encoder. If you set reset
    ///  to true, the count is set back to 0 directly after the
    ///  current count is read.
    ///  
    ///  The encoder has 24 steps per rotation
    ///  
    ///  Turning the encoder to the left decrements the counter,
    ///  so a negative count is possible.
    /// </summary>
    function GetCount(const reset: boolean): longint; virtual;

    /// <summary>
    ///  Sets the period with which the <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.OnCount"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  The <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.OnCount"/> callback is only triggered if the count has changed since the
    ///  last triggering.
    /// </summary>
    procedure SetCountCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.SetCountCallbackPeriod"/>.
    /// </summary>
    function GetCountCallbackPeriod: longword; virtual;

    /// <summary>
    ///  Sets the thresholds for the <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.OnCountReached"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Callback is turned off"
    ///   "'o'",    "Callback is triggered when the count is *outside* the min and max values"
    ///   "'i'",    "Callback is triggered when the count is *inside* the min and max values"
    ///   "'&lt;'",    "Callback is triggered when the count is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Callback is triggered when the count is greater than the min value (max is ignored)"
    ///  </code>
    /// </summary>
    procedure SetCountCallbackThreshold(const option: char; const min: longint; const max: longint); virtual;

    /// <summary>
    ///  Returns the threshold as set by <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.SetCountCallbackThreshold"/>.
    /// </summary>
    procedure GetCountCallbackThreshold(out option: char; out min: longint; out max: longint); virtual;

    /// <summary>
    ///  Sets the period with which the threshold callback
    ///  
    ///  * <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.OnCountReached"/>
    ///  
    ///  is triggered, if the thresholds
    ///  
    ///  * <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.SetCountCallbackThreshold"/>
    ///  
    ///  keeps being reached.
    /// </summary>
    procedure SetDebouncePeriod(const debounce: longword); virtual;

    /// <summary>
    ///  Returns the debounce period as set by <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.SetDebouncePeriod"/>.
    /// </summary>
    function GetDebouncePeriod: longword; virtual;

    /// <summary>
    ///  Returns *true* if the button is pressed and *false* otherwise.
    ///  
    ///  It is recommended to use the <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.OnPressed"/> and <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.OnReleased"/> callbacks
    ///  to handle the button.
    /// </summary>
    function IsPressed: boolean; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.SetCountCallbackPeriod"/>. The parameter is the count of
    ///  the encoder.
    ///  
    ///  The <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.OnCount"/> callback is only triggered if the count has changed since the
    ///  last triggering.
    /// </summary>
    property OnCount: TBrickletRotaryEncoderNotifyCount read countCallback write countCallback;

    /// <summary>
    ///  This callback is triggered when the threshold as set by
    ///  <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.SetCountCallbackThreshold"/> is reached.
    ///  The parameter is the count of the encoder.
    ///  
    ///  If the threshold keeps being reached, the callback is triggered periodically
    ///  with the period as set by <see cref="BrickletRotaryEncoder.TBrickletRotaryEncoder.SetDebouncePeriod"/>.
    /// </summary>
    property OnCountReached: TBrickletRotaryEncoderNotifyCountReached read countReachedCallback write countReachedCallback;

    /// <summary>
    ///  This callback is triggered when the button is pressed.
    /// </summary>
    property OnPressed: TBrickletRotaryEncoderNotifyPressed read pressedCallback write pressedCallback;

    /// <summary>
    ///  This callback is triggered when the button is released.
    /// </summary>
    property OnReleased: TBrickletRotaryEncoderNotifyReleased read releasedCallback write releasedCallback;
  end;

implementation

constructor TBrickletRotaryEncoder.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_ROTARY_ENCODER_DEVICE_IDENTIFIER, BRICKLET_ROTARY_ENCODER_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_ROTARY_ENCODER_FUNCTION_GET_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_FUNCTION_SET_COUNT_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_FUNCTION_GET_COUNT_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_FUNCTION_SET_COUNT_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_FUNCTION_GET_COUNT_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_FUNCTION_SET_DEBOUNCE_PERIOD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_FUNCTION_GET_DEBOUNCE_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_FUNCTION_IS_PRESSED] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_ROTARY_ENCODER_CALLBACK_COUNT] := {$ifdef FPC}@{$endif}CallbackWrapperCount;
  callbackWrappers[BRICKLET_ROTARY_ENCODER_CALLBACK_COUNT_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperCountReached;
  callbackWrappers[BRICKLET_ROTARY_ENCODER_CALLBACK_PRESSED] := {$ifdef FPC}@{$endif}CallbackWrapperPressed;
  callbackWrappers[BRICKLET_ROTARY_ENCODER_CALLBACK_RELEASED] := {$ifdef FPC}@{$endif}CallbackWrapperReleased;

  (ipcon as TIPConnection).AddDevice(self);
end;

function TBrickletRotaryEncoder.GetCount(const reset: boolean): longint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_FUNCTION_GET_COUNT, 9);
  LEConvertBooleanTo(reset, 8, request);
  response := SendRequest(request, 12);
  result := LEConvertInt32From(8, response);
end;

procedure TBrickletRotaryEncoder.SetCountCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_FUNCTION_SET_COUNT_CALLBACK_PERIOD, 12);
  LEConvertUInt32To(period, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRotaryEncoder.GetCountCallbackPeriod: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_FUNCTION_GET_COUNT_CALLBACK_PERIOD, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletRotaryEncoder.SetCountCallbackThreshold(const option: char; const min: longint; const max: longint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_FUNCTION_SET_COUNT_CALLBACK_THRESHOLD, 17);
  LEConvertCharTo(option, 8, request);
  LEConvertInt32To(min, 9, request);
  LEConvertInt32To(max, 13, request);
  SendRequest(request, 0);
end;

procedure TBrickletRotaryEncoder.GetCountCallbackThreshold(out option: char; out min: longint; out max: longint);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_FUNCTION_GET_COUNT_CALLBACK_THRESHOLD, 8);
  response := SendRequest(request, 17);
  option := LEConvertCharFrom(8, response);
  min := LEConvertInt32From(9, response);
  max := LEConvertInt32From(13, response);
end;

procedure TBrickletRotaryEncoder.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_FUNCTION_SET_DEBOUNCE_PERIOD, 12);
  LEConvertUInt32To(debounce, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRotaryEncoder.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_FUNCTION_GET_DEBOUNCE_PERIOD, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

function TBrickletRotaryEncoder.IsPressed: boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_FUNCTION_IS_PRESSED, 8);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletRotaryEncoder.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletRotaryEncoder.CallbackWrapperCount(const packet: TByteArray);
var count: longint;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  count := LEConvertInt32From(8, packet);
  if (Assigned(countCallback)) then begin
    countCallback(self, count);
  end;
end;

procedure TBrickletRotaryEncoder.CallbackWrapperCountReached(const packet: TByteArray);
var count: longint;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  count := LEConvertInt32From(8, packet);
  if (Assigned(countReachedCallback)) then begin
    countReachedCallback(self, count);
  end;
end;

procedure TBrickletRotaryEncoder.CallbackWrapperPressed(const packet: TByteArray);
begin
  if (Length(packet) <> 8) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  if (Assigned(pressedCallback)) then begin
    pressedCallback(self);
  end;
end;

procedure TBrickletRotaryEncoder.CallbackWrapperReleased(const packet: TByteArray);
begin
  if (Length(packet) <> 8) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  if (Assigned(releasedCallback)) then begin
    releasedCallback(self);
  end;
end;

end.
