{
  This file was automatically generated on 2021-01-15.

  Delphi/Lazarus Bindings Version 2.1.30

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletSegmentDisplay4x7V2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_DEVICE_IDENTIFIER = 2137;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_DEVICE_DISPLAY_NAME = 'Segment Display 4x7 Bricklet 2.0';

  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_SEGMENTS = 1;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_SEGMENTS = 2;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_BRIGHTNESS = 3;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_BRIGHTNESS = 4;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_NUMERIC_VALUE = 5;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_SELECTED_SEGMENT = 6;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_SELECTED_SEGMENT = 7;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_START_COUNTER = 8;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_COUNTER_VALUE = 9;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_RESET = 243;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_READ_UID = 249;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_SEGMENT_DISPLAY_4X7_V2_CALLBACK_COUNTER_FINISHED = 10;

  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_SEGMENT_DISPLAY_4X7_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To1OfBoolean = array [0..1] of boolean;
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To3OfInt8 = array [0..3] of shortint;
  TArray0To63OfUInt8 = array [0..63] of byte;
  TArray0To7OfBoolean = array [0..7] of boolean;

  TBrickletSegmentDisplay4x7V2 = class;
  TBrickletSegmentDisplay4x7V2NotifyCounterFinished = procedure(sender: TBrickletSegmentDisplay4x7V2) of object;

  /// <summary>
  ///  Four 7-segment displays with switchable dots
  /// </summary>
  TBrickletSegmentDisplay4x7V2 = class(TDevice)
  private
    counterFinishedCallback: TBrickletSegmentDisplay4x7V2NotifyCounterFinished;
  protected
    procedure CallbackWrapperCounterFinished(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Sets the segments of the Segment Display 4x7 Bricklet 2.0 segment-by-segment.
    ///  
    ///  The data is split into the four digits, two colon dots and the tick mark.
    ///  
    ///  The indices of the segments in the digit and colon parameters are as follows:
    ///  
    ///  .. image:: /Images/Bricklets/bricklet_segment_display_4x7_v2_segment_index.png
    ///     :scale: 100 %
    ///     :alt: Indices of segments
    ///     :align: center
    /// </summary>
    procedure SetSegments(const digit0: array of boolean; const digit1: array of boolean; const digit2: array of boolean; const digit3: array of boolean; const colon: array of boolean; const tick: boolean); virtual;

    /// <summary>
    ///  Returns the segment data as set by <see cref="BrickletSegmentDisplay4x7V2.TBrickletSegmentDisplay4x7V2.SetSegments"/>.
    /// </summary>
    procedure GetSegments(out digit0: TArray0To7OfBoolean; out digit1: TArray0To7OfBoolean; out digit2: TArray0To7OfBoolean; out digit3: TArray0To7OfBoolean; out colon: TArray0To1OfBoolean; out tick: boolean); virtual;

    /// <summary>
    ///  The brightness can be set between 0 (dark) and 7 (bright).
    /// </summary>
    procedure SetBrightness(const brightness: byte); virtual;

    /// <summary>
    ///  Returns the brightness as set by <see cref="BrickletSegmentDisplay4x7V2.TBrickletSegmentDisplay4x7V2.SetBrightness"/>.
    /// </summary>
    function GetBrightness: byte; virtual;

    /// <summary>
    ///  Sets a numeric value for each of the digits. They represent:
    ///  
    ///  * -2: minus sign
    ///  * -1: blank
    ///  * 0-9: 0-9
    ///  * 10: A
    ///  * 11: b
    ///  * 12: C
    ///  * 13: d
    ///  * 14: E
    ///  * 15: F
    ///  
    ///  Example: A call with [-2, -1, 4, 2] will result in a display of "- 42".
    /// </summary>
    procedure SetNumericValue(const value: array of shortint); virtual;

    /// <summary>
    ///  Turns one specified segment on or off.
    ///  
    ///  The indices of the segments are as follows:
    ///  
    ///  .. image:: /Images/Bricklets/bricklet_segment_display_4x7_v2_selected_segment_index.png
    ///     :scale: 100 %
    ///     :alt: Indices of selected segments
    ///     :align: center
    /// </summary>
    procedure SetSelectedSegment(const segment: byte; const value: boolean); virtual;

    /// <summary>
    ///  Returns the value of a single segment.
    /// </summary>
    function GetSelectedSegment(const segment: byte): boolean; virtual;

    /// <summary>
    ///  Starts a counter with the *from* value that counts to the *to*
    ///  value with the each step incremented by *increment*.
    ///  *length* is the pause between each increment.
    ///  
    ///  Example: If you set *from* to 0, *to* to 100, *increment* to 1 and
    ///  *length* to 1000, a counter that goes from 0 to 100 with one second
    ///  pause between each increment will be started.
    ///  
    ///  Using a negative *increment* allows to count backwards.
    ///  
    ///  You can stop the counter at every time by calling <see cref="BrickletSegmentDisplay4x7V2.TBrickletSegmentDisplay4x7V2.SetSegments"/>
    ///  or <see cref="BrickletSegmentDisplay4x7V2.TBrickletSegmentDisplay4x7V2.SetNumericValue"/>.
    /// </summary>
    procedure StartCounter(const valueFrom: smallint; const valueTo: smallint; const increment: smallint; const length_: longword); virtual;

    /// <summary>
    ///  Returns the counter value that is currently shown on the display.
    ///  
    ///  If there is no counter running a 0 will be returned.
    /// </summary>
    function GetCounterValue: word; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletSegmentDisplay4x7V2.TBrickletSegmentDisplay4x7V2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletSegmentDisplay4x7V2.TBrickletSegmentDisplay4x7V2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletSegmentDisplay4x7V2.TBrickletSegmentDisplay4x7V2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletSegmentDisplay4x7V2.TBrickletSegmentDisplay4x7V2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered when the counter (see <see cref="BrickletSegmentDisplay4x7V2.TBrickletSegmentDisplay4x7V2.StartCounter"/>) is
    ///  finished.
    /// </summary>
    property OnCounterFinished: TBrickletSegmentDisplay4x7V2NotifyCounterFinished read counterFinishedCallback write counterFinishedCallback;
  end;

implementation

constructor TBrickletSegmentDisplay4x7V2.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_SEGMENT_DISPLAY_4X7_V2_DEVICE_IDENTIFIER, BRICKLET_SEGMENT_DISPLAY_4X7_V2_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_SEGMENTS] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_SEGMENTS] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_BRIGHTNESS] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_BRIGHTNESS] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_NUMERIC_VALUE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_SELECTED_SEGMENT] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_SELECTED_SEGMENT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_START_COUNTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_COUNTER_VALUE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_SEGMENT_DISPLAY_4X7_V2_CALLBACK_COUNTER_FINISHED] := {$ifdef FPC}@{$endif}CallbackWrapperCounterFinished;

  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletSegmentDisplay4x7V2.SetSegments(const digit0: array of boolean; const digit1: array of boolean; const digit2: array of boolean; const digit3: array of boolean; const colon: array of boolean; const tick: boolean);
var request: TByteArray; i: longint; digit0Bits: array [0..0] of byte; digit1Bits: array [0..0] of byte; digit2Bits: array [0..0] of byte; digit3Bits: array [0..0] of byte; colonBits: array [0..0] of byte;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_SEGMENTS, 14);
  if (Length(digit0) <> 8) then raise EInvalidParameterException.Create('Digit0 has to be exactly 8 items long');
  FillChar(digit0Bits[0], Length(digit0Bits) * SizeOf(digit0Bits[0]), 0);
  for i := 0 to 7 do if digit0[i] then digit0Bits[Floor(i/8)] := digit0Bits[Floor(i/8)] or (1 shl (i mod 8));
  for i := 0 to 0 do LEConvertUInt8To(digit0Bits[i], 8 + (i * 1), request);
  if (Length(digit1) <> 8) then raise EInvalidParameterException.Create('Digit1 has to be exactly 8 items long');
  FillChar(digit1Bits[0], Length(digit1Bits) * SizeOf(digit1Bits[0]), 0);
  for i := 0 to 7 do if digit1[i] then digit1Bits[Floor(i/8)] := digit1Bits[Floor(i/8)] or (1 shl (i mod 8));
  for i := 0 to 0 do LEConvertUInt8To(digit1Bits[i], 9 + (i * 1), request);
  if (Length(digit2) <> 8) then raise EInvalidParameterException.Create('Digit2 has to be exactly 8 items long');
  FillChar(digit2Bits[0], Length(digit2Bits) * SizeOf(digit2Bits[0]), 0);
  for i := 0 to 7 do if digit2[i] then digit2Bits[Floor(i/8)] := digit2Bits[Floor(i/8)] or (1 shl (i mod 8));
  for i := 0 to 0 do LEConvertUInt8To(digit2Bits[i], 10 + (i * 1), request);
  if (Length(digit3) <> 8) then raise EInvalidParameterException.Create('Digit3 has to be exactly 8 items long');
  FillChar(digit3Bits[0], Length(digit3Bits) * SizeOf(digit3Bits[0]), 0);
  for i := 0 to 7 do if digit3[i] then digit3Bits[Floor(i/8)] := digit3Bits[Floor(i/8)] or (1 shl (i mod 8));
  for i := 0 to 0 do LEConvertUInt8To(digit3Bits[i], 11 + (i * 1), request);
  if (Length(colon) <> 2) then raise EInvalidParameterException.Create('Colon has to be exactly 2 items long');
  FillChar(colonBits[0], Length(colonBits) * SizeOf(colonBits[0]), 0);
  for i := 0 to 1 do if colon[i] then colonBits[Floor(i/8)] := colonBits[Floor(i/8)] or (1 shl (i mod 8));
  for i := 0 to 0 do LEConvertUInt8To(colonBits[i], 12 + (i * 1), request);
  LEConvertBooleanTo(tick, 13, request);
  SendRequest(request, 0);
end;

procedure TBrickletSegmentDisplay4x7V2.GetSegments(out digit0: TArray0To7OfBoolean; out digit1: TArray0To7OfBoolean; out digit2: TArray0To7OfBoolean; out digit3: TArray0To7OfBoolean; out colon: TArray0To1OfBoolean; out tick: boolean);
var request, response: TByteArray; i: longint; digit0Bits: array [0..0] of byte; digit1Bits: array [0..0] of byte; digit2Bits: array [0..0] of byte; digit3Bits: array [0..0] of byte; colonBits: array [0..0] of byte;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_SEGMENTS, 8);
  response := SendRequest(request, 14);
  FillChar(digit0Bits[0], Length(digit0Bits) * SizeOf(digit0Bits[0]), 0);
  for i := 0 to 0 do digit0Bits[i] := LEConvertUInt8From(8 + (i * 1), response);
  for i := 0 to 7 do digit0[i] := ((digit0Bits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
  FillChar(digit1Bits[0], Length(digit1Bits) * SizeOf(digit1Bits[0]), 0);
  for i := 0 to 0 do digit1Bits[i] := LEConvertUInt8From(9 + (i * 1), response);
  for i := 0 to 7 do digit1[i] := ((digit1Bits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
  FillChar(digit2Bits[0], Length(digit2Bits) * SizeOf(digit2Bits[0]), 0);
  for i := 0 to 0 do digit2Bits[i] := LEConvertUInt8From(10 + (i * 1), response);
  for i := 0 to 7 do digit2[i] := ((digit2Bits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
  FillChar(digit3Bits[0], Length(digit3Bits) * SizeOf(digit3Bits[0]), 0);
  for i := 0 to 0 do digit3Bits[i] := LEConvertUInt8From(11 + (i * 1), response);
  for i := 0 to 7 do digit3[i] := ((digit3Bits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
  FillChar(colonBits[0], Length(colonBits) * SizeOf(colonBits[0]), 0);
  for i := 0 to 0 do colonBits[i] := LEConvertUInt8From(12 + (i * 1), response);
  for i := 0 to 1 do colon[i] := ((colonBits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
  tick := LEConvertBooleanFrom(13, response);
end;

procedure TBrickletSegmentDisplay4x7V2.SetBrightness(const brightness: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_BRIGHTNESS, 9);
  LEConvertUInt8To(brightness, 8, request);
  SendRequest(request, 0);
end;

function TBrickletSegmentDisplay4x7V2.GetBrightness: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_BRIGHTNESS, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletSegmentDisplay4x7V2.SetNumericValue(const value: array of shortint);
var request: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_NUMERIC_VALUE, 12);
  if (Length(value) <> 4) then raise EInvalidParameterException.Create('Value has to be exactly 4 items long');
  for i := 0 to Length(value) - 1 do LEConvertInt8To(value[i], 8 + (i * 1), request);
  SendRequest(request, 0);
end;

procedure TBrickletSegmentDisplay4x7V2.SetSelectedSegment(const segment: byte; const value: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_SELECTED_SEGMENT, 10);
  LEConvertUInt8To(segment, 8, request);
  LEConvertBooleanTo(value, 9, request);
  SendRequest(request, 0);
end;

function TBrickletSegmentDisplay4x7V2.GetSelectedSegment(const segment: byte): boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_SELECTED_SEGMENT, 9);
  LEConvertUInt8To(segment, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletSegmentDisplay4x7V2.StartCounter(const valueFrom: smallint; const valueTo: smallint; const increment: smallint; const length_: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_START_COUNTER, 18);
  LEConvertInt16To(valueFrom, 8, request);
  LEConvertInt16To(valueTo, 10, request);
  LEConvertInt16To(increment, 12, request);
  LEConvertUInt32To(length_, 14, request);
  SendRequest(request, 0);
end;

function TBrickletSegmentDisplay4x7V2.GetCounterValue: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_COUNTER_VALUE, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletSegmentDisplay4x7V2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletSegmentDisplay4x7V2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletSegmentDisplay4x7V2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletSegmentDisplay4x7V2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletSegmentDisplay4x7V2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletSegmentDisplay4x7V2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletSegmentDisplay4x7V2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletSegmentDisplay4x7V2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletSegmentDisplay4x7V2.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletSegmentDisplay4x7V2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletSegmentDisplay4x7V2.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletSegmentDisplay4x7V2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SEGMENT_DISPLAY_4X7_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletSegmentDisplay4x7V2.CallbackWrapperCounterFinished(const packet: TByteArray);
begin
  if (Length(packet) <> 8) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  if (Assigned(counterFinishedCallback)) then begin
    counterFinishedCallback(self);
  end;
end;

end.
